// naumann@stce.rwth-aachen.de
#include<iostream>
#include<limits>
#include<cmath>

template<typename T>
T f(T x) { return 3*x*x; }

template<typename T>
T dfdx(T x) {
  const T eps=std::numeric_limits<T>::epsilon();
  const T h= (x==0) ? sqrt(eps) : sqrt(eps)*fabs(x);
  return (f(x+h)-f(x-h))/(2*h);
}

int main() {
  float x=1;
  std::cout << dfdx(x) << std::endl;
  return 0;
}

