// naumann@stce.rwth-aachen.de
#include<iostream>
#include<cmath>
#include<limits>

template<typename T>
T f(T x) { return exp(x); }

template<typename T>
T dfdx(T x, T h) {
  return (f(x+h)-f(x-h))/(2*h);
}

template<typename T>
T ddfdxx(T x, T h) {
  return (dfdx(x+h,h)-dfdx(x-h,h))/(2*h);
}

template<typename T>
T dddfdxxx(T x, T h) {
  return (ddfdxx(x+h,h)-ddfdxx(x-h,h))/(2*h);
}

template<typename T>
T ddddfdxxxx(T x, T h) {
  return (dddfdxxx(x+h,h)-dddfdxxx(x-h,h))/(2*h);
}

int main() {
  using namespace std;
  using T=float;
  T x=0;
  for (T h=1;h>std::numeric_limits<T>::epsilon();h/=10) 
    std::cout << h << "\t" 
              << dfdx(x,h) << "\t" 
	      << ddfdxx(x,h) << "\t" 
	      << dddfdxxx(x,h) << "\t" 
	      << ddddfdxxxx(x,h) << std::endl;
  return 0;
}
