// naumann@stce.rwth-aachen.de

#include <iostream> 
#include <cassert> 
#include <cmath> 
#include <limits> 

using T=double;

T estimate(T x1, T y1, T x2, T y2) {
  T d=(pow(x1,2)+pow(x2,2)); 
  assert(d!=0); 
  return (x1*y1+x2*y2)/d; 
}

int main() {
  using namespace std;
  T x1=0,x2=0,y1=0,y2=0,eps=std::numeric_limits<T>::epsilon(),h;
  cout << "x1="; cin >> x1; cout << "y1="; cin >> y1;
  cout << "x2="; cin >> x2; cout << "y2="; cin >> y2;
  h= (x1==0) ? sqrt(eps) : sqrt(eps)*fabs(x1); // dp/dx1
  cout << (estimate(x1+h,y1,x2,y2)-estimate(x1-h,y1,x2,y2))/(2*h) << endl;
  h= (x2==0) ? sqrt(eps) : sqrt(eps)*fabs(x2); // dp/dx2
  cout << (estimate(x1,y1,x2+h,y2)-estimate(x1,y1,x2-h,y2))/(2*h) << endl;
  h= (y1==0) ? sqrt(eps) : sqrt(eps)*fabs(y1); // dp/dy1
  cout << (estimate(x1,y1+h,x2,y2)-estimate(x1,y1-h,x2,y2))/(2*h) << endl;
  h= (y2==0) ? sqrt(eps) : sqrt(eps)*fabs(y2); // dp/dy2
  cout << (estimate(x1,y1,x2,y2+h)-estimate(x1,y1,x2,y2-h))/(2*h) << endl;
  return 0;
}
